import { HttpClient } from '@angular/common/http';
import { EventEmitter, Injectable, Output } from '@angular/core';
import { User } from '../user';
import { map, Observable } from  'rxjs';

@Injectable({
  providedIn: 'root'
})
export class UserService {

  public baseUrl = "http://localhost/bildungdb/api/";

  redirectUrl?: string;

@Output() getLoggedInName: EventEmitter<any> = new EventEmitter();
  
constructor(private httpClient : HttpClient) { }
  
public userlogin(username:string, password:string) {
    return this.httpClient.post<any>(this.baseUrl + '/login.php', { username, password })
        .pipe(map((Usermodule: { name: string; }[]) => {
            this.setToken(Usermodule[0].name);
            this.getLoggedInName.emit(true);
            return Usermodule;
        }));
}
public userregistration(name: string,email: string,pwd: string,login: string) {
  return this.httpClient.post<any>(this.baseUrl + '/registration.php', { name,email, pwd,login })
      .pipe(map(Usermodule => {
          return Usermodule;
      }));
}
//token
setToken(token: string) {
  localStorage.setItem('token', token);
}
 
getToken() {
  return localStorage.getItem('token');
}
 
deleteToken() {
  localStorage.removeItem('token');
}
 
isLoggedIn() {
  const usertoken = this.getToken();
  if (usertoken != null) {
    return true
  }
  return false;
}

getUsers() {
    return this.httpClient.get<User[]>(this.baseUrl + "/user.php");
  }

  }
